﻿using System;
using TwinCAT.Ads;

namespace BeckhoffAdsTester3
{
    class Program
    {
        static void Main(string[] args)
        {
            //创建客户端实例类，通过对应的AmsNetId连接到851端口，新建变量
            AdsClient client = new AdsClient();
            uint varHandle1 = 0;
            uint varHandle2 = 0;
            uint varHandle3 = 0;
            uint varHandle4 = 0 ;
            

            client.Connect(AmsNetId.Local, 851);
            try
            {
                //给读回写入的变量赋初值
                uint valueToRead1 = 0;
                double valueToRead2 = 0;
                bool valueToRead3 ;
                uint valueToWrite = 42;

                //将想读的变量给varHandle1
                varHandle1 = client.CreateVariableHandle("MAIN.i_value");
                varHandle2 = client.CreateVariableHandle("MAIN.f_value");
                varHandle3 = client.CreateVariableHandle("MAIN.b_value");
                varHandle4 = client.CreateVariableHandle("MAIN.i_valuewritten");


                //写入值
                //client.WriteAny(varHandle4, valueToWrite);

                //读取值
                valueToRead1 = (uint)client.ReadAny(varHandle1, typeof(uint));
                valueToRead2 = (double)client.ReadAny(varHandle2, typeof(double));
                valueToRead3 = (bool)client.ReadAny(varHandle3, typeof(bool));

                //输出结果
                Console.WriteLine("读取到的变量值i_value为：{0}", valueToRead1);
                Console.WriteLine("读取到的变量值f_value为：{0}", valueToRead2);
                Console.WriteLine("读取到的变量值b_value为：{0}", valueToRead3);
            }
            finally
            {
                //释放缓存
                client.DeleteVariableHandle(varHandle1);
                client.DeleteVariableHandle(varHandle2);
                client.DeleteVariableHandle(varHandle3);

            }
        }
    }
}
